]> git.sesse.net Git - ffmpeg/blob - tests/fate.sh
Merge commit '2578f1efd64f4efc30114c328d1eff9030429e59'
[ffmpeg] / tests / fate.sh
1 #! /bin/sh
2
3 config=$1
4
5 die(){
6     echo "$@"
7     exit 1
8 }
9
10 test -r "$config"  || die "usage: fate.sh <config>"
11
12 workdir=$(cd $(dirname $config) && pwd)
13 make=make
14 tar='tar c'
15
16 . "$config"
17
18 test -n "$slot"    || die "slot not specified"
19 test -n "$repo"    || die "repo not specified"
20 test -d "$samples" || die "samples location not specified"
21
22 lock(){
23     lock=$1/fate.lock
24     (set -C; exec >$lock) 2>/dev/null || return
25     trap 'rm $lock' EXIT
26 }
27
28 checkout(){
29     case "$repo" in
30         file:*|/*) src="${repo#file:}"      ;;
31         git:*)     git clone "$repo" "$src" ;;
32     esac
33 }
34
35 update()(
36     cd ${src} || return
37     case "$repo" in
38         git:*) git pull --quiet ;;
39     esac
40 )
41
42 configure()(
43     cd ${build} || return
44     ${shell} ${src}/configure                                           \
45         --prefix="${inst}"                                              \
46         --samples="${samples}"                                          \
47         --enable-gpl                                                    \
48         --enable-memory-poisoning                                       \
49         ${arch:+--arch=$arch}                                           \
50         ${cpu:+--cpu="$cpu"}                                            \
51         ${cross_prefix:+--cross-prefix="$cross_prefix"}                 \
52         ${as:+--as="$as"}                                               \
53         ${cc:+--cc="$cc"}                                               \
54         ${ld:+--ld="$ld"}                                               \
55         ${target_os:+--target-os="$target_os"}                          \
56         ${sysroot:+--sysroot="$sysroot"}                                \
57         ${target_exec:+--target-exec="$target_exec"}                    \
58         ${target_path:+--target-path="$target_path"}                    \
59         ${target_samples:+--target-samples="$target_samples"}           \
60         ${extra_cflags:+--extra-cflags="$extra_cflags"}                 \
61         ${extra_ldflags:+--extra-ldflags="$extra_ldflags"}              \
62         ${extra_libs:+--extra-libs="$extra_libs"}                       \
63         ${extra_conf}
64 )
65
66 compile()(
67     cd ${build} || return
68     ${make} ${makeopts} && ${make} install
69 )
70
71 fate()(
72     test "$build_only" = "yes" && return
73     cd ${build} || return
74     ${make} ${makeopts} -k fate
75 )
76
77 clean(){
78     rm -rf ${build} ${inst}
79 }
80
81 report(){
82     date=$(date -u +%Y%m%d%H%M%S)
83     echo "fate:0:${date}:${slot}:${version}:$1:$2:${comment}" >report
84     cat ${build}/config.fate ${build}/tests/data/fate/*.rep >>report
85     test -n "$fate_recv" && $tar report *.log | gzip | $fate_recv
86 }
87
88 fail(){
89     report "$@"
90     clean
91     exit
92 }
93
94 mkdir -p ${workdir} || die "Error creating ${workdir}"
95 lock ${workdir}     || die "${workdir} locked"
96 cd ${workdir}       || die "cd ${workdir} failed"
97
98 src=${workdir}/src
99 : ${build:=${workdir}/build}
100 : ${inst:=${workdir}/install}
101
102 test -d "$src" && update || checkout || die "Error fetching source"
103
104 cd ${workdir}
105
106 version=$(${src}/version.sh ${src})
107 test "$version" = "$(cat version-$slot 2>/dev/null)" && exit 0
108 echo ${version} >version-$slot
109
110 rm -rf "${build}" *.log
111 mkdir -p ${build}
112
113 configure >configure.log 2>&1 || fail $? "error configuring"
114 compile   >compile.log   2>&1 || fail $? "error compiling"
115 fate      >test.log      2>&1 || fail $? "error testing"
116 report 0 success
117 clean